diff --git a/hardware/openzwave/command_classes/Battery.h b/hardware/openzwave/command_classes/Battery.h
index 867f76157a..37753fa5e6 100644
--- a/hardware/openzwave/command_classes/Battery.h
+++ b/hardware/openzwave/command_classes/Battery.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_BATTERY (0x80), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Battery: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/CRC16Encap.h b/hardware/openzwave/command_classes/CRC16Encap.h
index d89e8788ab..3317510247 100644
--- a/hardware/openzwave/command_classes/CRC16Encap.h
+++ b/hardware/openzwave/command_classes/CRC16Encap.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_CRC_16_ENCAP (0x56), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class CRC16Encap: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/CentralScene.h b/hardware/openzwave/command_classes/CentralScene.h
index 0a869c4381..c7ea4d5e75 100644
--- a/hardware/openzwave/command_classes/CentralScene.h
+++ b/hardware/openzwave/command_classes/CentralScene.h
@@ -29,14 +29,16 @@
 #define _CentralScene_H
 
 #include "command_classes/CommandClass.h"
+#include "TimerThread.h"
 
 namespace OpenZWave
 {
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_CENTRAL_SCENE (0x5B), a Z-Wave device command class.
+	 *  \ingroup CommandClass
 	 */
-	class CentralScene: public CommandClass
+	class CentralScene: public CommandClass, private Timer
 	{
 	public:
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new CentralScene( _homeId, _nodeId ); }
@@ -57,6 +59,10 @@ namespace OpenZWave
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		/** \brief Create Default Vars for this CC */
 		void CreateVars( uint8 const _instance );
+		bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
+		bool RequestValue( uint32 const _requestFlags, uint16 const _what, uint8 const _instance, Driver::MsgQueue const _queue );
+		bool SetValue( Value const& _value);
+	private:
 		/**
 		 * Creates the ValueIDs for the keyAttributes
 		 * @param identical
@@ -64,14 +70,12 @@ namespace OpenZWave
 		 * @param sceneNumber
 		 * @return
 		 */
-		void createSupportedKeyAttributesValues(uint8 keyAttributes, uint8 sceneNumber, uint8 index, uint8 instance);
-		void ReadXML( TiXmlElement const* _ccElement	);
-		void WriteXML( TiXmlElement* _ccElement );
-		bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		bool RequestValue( uint32 const _requestFlags, uint8 const _what, uint8 const _instance, Driver::MsgQueue const _queue );
-	private:
+		void createSupportedKeyAttributesValues(uint8 keyAttributes, uint8 sceneNumber, uint8 instance);
+		void ClearScene(uint32 sceneID);
 		CentralScene( uint32 const _homeId, uint8 const _nodeId );
-		int32 m_scenecount;
+		bool m_slowrefresh;
+		uint8 m_sequence;
+		std::map<uint32, uint32> m_TimersSet;
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/ClimateControlSchedule.h b/hardware/openzwave/command_classes/ClimateControlSchedule.h
index 93fa2f4509..41676f7969 100644
--- a/hardware/openzwave/command_classes/ClimateControlSchedule.h
+++ b/hardware/openzwave/command_classes/ClimateControlSchedule.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_CLIMATE_CONTROL_SCHEDULE (0x46), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ClimateControlSchedule: public CommandClass
 	{
@@ -48,10 +49,8 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_CLIMATE_CONTROL_SCHEDULE"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -61,8 +60,7 @@ namespace OpenZWave
 		virtual void CreateVars( uint8 const _instance );
 
 	private:
-		ClimateControlSchedule( uint32 const _homeId, uint8 const _nodeId ): CommandClass( _homeId, _nodeId ), m_changeCounter( 0 ){}
-		uint8	m_changeCounter;
+		ClimateControlSchedule( uint32 const _homeId, uint8 const _nodeId );
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/Clock.h b/hardware/openzwave/command_classes/Clock.h
index 568453139c..01907a7e15 100644
--- a/hardware/openzwave/command_classes/Clock.h
+++ b/hardware/openzwave/command_classes/Clock.h
@@ -36,6 +36,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_CLOCK (0x81), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Clock: public CommandClass
 	{
@@ -48,7 +49,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/Color.h b/hardware/openzwave/command_classes/Color.h
index 113ecc3b1a..38da5953ee 100644
--- a/hardware/openzwave/command_classes/Color.h
+++ b/hardware/openzwave/command_classes/Color.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_COLOR (0x33), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Color: public CommandClass
 	{
@@ -46,10 +47,8 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_COLOR"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		bool RequestColorChannelReport(	uint8 const coloridx, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
@@ -63,8 +62,6 @@ namespace OpenZWave
 
 	private:
 		Color( uint32 const _homeId, uint8 const _nodeId );
-		uint16 m_capabilities;
-		bool m_coloridxbug; // Fibaro RGBW before version 25.25 always reported the coloridx as 3 in the Report Message. Work around it
 		bool m_refreshinprogress;
 		uint8 m_coloridxcount;
 		uint8 m_colorvalues[9];
diff --git a/hardware/openzwave/command_classes/CommandClass.h b/hardware/openzwave/command_classes/CommandClass.h
index 2fdede8223..936ee94e70 100644
--- a/hardware/openzwave/command_classes/CommandClass.h
+++ b/hardware/openzwave/command_classes/CommandClass.h
@@ -34,168 +34,181 @@
 #include "Defs.h"
 #include "Bitfield.h"
 #include "Driver.h"
+#include "CompatOptionManager.h"
 
 namespace OpenZWave
 {
-	class Msg;
-	class Node;
-	class Value;
+class Msg;
+class Node;
+class Value;
+/** \defgroup CommandClass Z-Wave CommandClass Support
+ *
+ * This is the CommandClasses that OZW currently supports. Typically, a Application does not need
+ * to be aware of the CommandClasses a Device exposes, as they would be transparently exposed to the
+ * application as ValueID's
+ */
+
+
+/** \brief Base class for all Z-Wave command classes.
+ * \ingroup CommandClass
+ */
+class OPENZWAVE_EXPORT CommandClass
+{
 
-	/** \brief Base class for all Z-Wave command classes.
-	 */
-	class OPENZWAVE_EXPORT CommandClass
+public:
+	enum
 	{
+		RequestFlag_Static		= 0x00000001,	/**< Values that never change. */
+		RequestFlag_Session		= 0x00000002,	/**< Values that change infrequently, and so only need to be requested at start up, or via a manual refresh. */
+		RequestFlag_Dynamic		= 0x00000004,	/**< Values that change and will be requested if polling is enabled on the node. */
+		RequestFlag_AfterMark	= 0x00000008	/**< Values relevent to Controlling CC, not Controlled CC. */
+	};
 
-	public:
-		enum
-		{
-			RequestFlag_Static		= 0x00000001,	/**< Values that never change. */
-			RequestFlag_Session		= 0x00000002,	/**< Values that change infrequently, and so only need to be requested at start up, or via a manual refresh. */
-			RequestFlag_Dynamic		= 0x00000004,	/**< Values that change and will be requested if polling is enabled on the node. */
-			RequestFlag_AfterMark	= 0x00000008	/**< Values relevent to Controlling CC, not Controlled CC. */
-		};
-
-		CommandClass( uint32 const _homeId, uint8 const _nodeId );
-		virtual ~CommandClass();
-
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
-		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue ){ return false; }
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue ) { return false; }
-
-		virtual uint8 const GetCommandClassId()const = 0;
-		virtual string const GetCommandClassName()const = 0;
-		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 ) = 0;
-		virtual bool SetValue( Value const& _value ){ return false; }
-		virtual void SetValueBasic( uint8 const _instance, uint8 const _level ){}		// Class specific handling of BASIC value mapping
-		virtual void SetVersion( uint8 const _version ){ m_version = _version; }
-
-		bool RequestStateForAllInstances( uint32 const _requestFlags, Driver::MsgQueue const _queue );
-		bool CheckForRefreshValues(Value const* _value );
-
-		// The highest version number of the command class implemented by OpenZWave.  We only need
-		// to do version gets on command classes that override this with a number greater than one.
-		virtual uint8 GetMaxVersion(){ return 1; }
-
-		uint8 GetVersion()const{ return m_version; }
-		Bitfield const* GetInstances()const{ return &m_instances; }
-		uint32 GetHomeId()const{ return m_homeId; }
-		uint8 GetNodeId()const{ return m_nodeId; }
-		Driver* GetDriver()const;
-		Node* GetNodeUnsafe()const;
-		Value* GetValue( uint8 const _instance, uint8 const _index );
-		bool RemoveValue( uint8 const _instance, uint8 const _index );
-		uint8 GetEndPoint( uint8 const _instance )
-		{
-			map<uint8,uint8>::iterator it = m_endPointMap.find( _instance );
-			return( it == m_endPointMap.end() ? 0 : it->second );
-		}
-		uint8 GetInstance( uint8 const _endPoint )
+	CommandClass( uint32 const _homeId, uint8 const _nodeId );
+	virtual ~CommandClass();
+
+	virtual void ReadXML( TiXmlElement const* _ccElement );
+	virtual void WriteXML( TiXmlElement* _ccElement );
+	virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue ){ return false; }
+	virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue ) { return false; }
+	virtual void refreshValuesOnWakeup();
+
+
+	virtual uint8 const GetCommandClassId()const = 0;
+	virtual string const GetCommandClassName()const = 0;
+	string const GetCommandClassLabel();
+	void SetCommandClassLabel(string label);
+	virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 ) = 0;
+	virtual bool HandleIncomingMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 ) { return false; }
+	virtual bool SetValue( Value const& _value ){ return false; }
+	virtual void SetValueBasic( uint8 const _instance, uint8 const _level ){}		// Class specific handling of BASIC value mapping
+	virtual void SetVersion( uint8 const _version ); // Made out-of-line to allow checks against downgrade
+
+	bool RequestStateForAllInstances( uint32 const _requestFlags, Driver::MsgQueue const _queue );
+	bool CheckForRefreshValues(Value const* _value );
+
+	// The highest version number of the command class implemented by OpenZWave.  We only need
+	// to do version gets on command classes that override this with a number greater than one.
+	virtual uint8 GetMaxVersion(){ return 1; }
+
+	uint8 GetVersion()const{ return m_dom.GetFlagByte(STATE_FLAG_CCVERSION); }
+	Bitfield const* GetInstances()const{ return &m_instances; }
+	uint32 GetHomeId()const{ return m_homeId; }
+	uint8 GetNodeId()const{ return m_nodeId; }
+	Driver* GetDriver()const;
+	Node* GetNodeUnsafe()const;
+	Value* GetValue( uint8 const _instance, uint16 const _index );
+	bool RemoveValue( uint8 const _instance, uint16 const _index );
+	uint8 GetEndPoint( uint8 const _instance )
+	{
+		map<uint8,uint8>::iterator it = m_endPointMap.find( _instance );
+		return( it == m_endPointMap.end() ? 0 : it->second );
+	}
+	uint8 GetInstance( uint8 const _endPoint )
+	{
+		for( map<uint8,uint8>::iterator it = m_endPointMap.begin(); it != m_endPointMap.end(); ++it )
 		{
-			for( map<uint8,uint8>::iterator it = m_endPointMap.begin(); it != m_endPointMap.end(); ++it )
+			if( _endPoint == it->second )
 			{
-				if( _endPoint == it->second )
-				{
-					return it->first;
-				}
+				return it->first;
 			}
-			return 0;
 		}
-
-		void SetInstances( uint8 const _instances );
-		void SetInstance( uint8 const _endPoint );
-		void SetAfterMark(){ m_afterMark = true; }
-		void SetEndPoint( uint8 const _instance, uint8 const _endpoint){ m_endPointMap[_instance] = _endpoint; }
-		bool IsAfterMark()const{ return m_afterMark; }
-		bool IsCreateVars()const{ return m_createVars; }
-		bool IsGetSupported()const{ return m_getSupported; }
-		bool IsSecured()const{ return m_isSecured; }
-		void SetSecured(){ m_isSecured = true; }
-		bool IsSecureSupported()const { return m_SecureSupport; }
-		void ClearSecureSupport() { m_SecureSupport = false; }
-		void SetSecureSupport() { m_SecureSupport = true; }
-		void SetInNIF() { m_inNIF = true; }
-		bool IsInNIF() { return m_inNIF; }
-
-		// Helper methods
-		string ExtractValue( uint8 const* _data, uint8* _scale, uint8* _precision, uint8 _valueOffset = 1 )const;
-
-		/**
-		 *  Append a floating-point value to a message.
-		 *  \param _msg The message to which the value should be appended.
-		 *  \param _value A string containing a decimal number to be appended.
-		 *  \param _scale A byte indicating the scale corresponding to this value (e.g., 1=F and 0=C for temperatures).
-		 *  \see Msg
-		 */
-		void AppendValue( Msg* _msg, string const& _value, uint8 const _scale )const;
-		uint8 const GetAppendValueSize( string const& _value )const;
-		int32 ValueToInteger( string const& _value, uint8* o_precision, uint8* o_size )const;
-
-		void UpdateMappedClass( uint8 const _instance, uint8 const _classId, uint8 const _value );		// Update mapped class's value from BASIC class
-
-		typedef struct RefreshValue {
-			uint8 cc;
-			uint8 genre;
-			uint8 instance;
-			uint8 index;
-			std::vector<RefreshValue *> RefreshClasses;
-		} RefreshValue;
-
-	protected:
-		virtual void CreateVars( uint8 const _instance ){}
-		void ReadValueRefreshXML ( TiXmlElement const* _ccElement );
-
-	public:
-		virtual void CreateVars( uint8 const _instance, uint8 const _index ){}
-
-	private:
-		uint32		m_homeId;
-		uint8		m_nodeId;
-		uint8		m_version;
-		Bitfield	m_instances;
-OPENZWAVE_EXPORT_WARNINGS_OFF
-		map<uint8,uint8> m_endPointMap;
-OPENZWAVE_EXPORT_WARNINGS_ON
-		bool		m_afterMark;		// Set to true if the command class is listed after COMMAND_CLASS_MARK, and should not create any values.
-		bool		m_createVars;		// Do we want to create variables
-		int8		m_overridePrecision;	// Override precision when writing values if >=0
-		bool		m_getSupported;	    	// Get operation supported
-		bool		m_isSecured;		// is this command class secured with the Security Command Class
-		bool		m_SecureSupport; 	// Does this commandclass support secure encryption (eg, the Security CC doesn't encrypt itself, so it doesn't support encryption)
-		std::vector<RefreshValue *> m_RefreshClassValues; // what Command Class Values should we refresh ?
-		bool		m_inNIF; 			// Was this command class present in the NIF Frame we recieved (or was it created from our device_classes.xml file, or because it was in the Security SupportedReport message
+		return 0;
+	}
+
+	void SetInstances( uint8 const _instances );
+	void SetInstance( uint8 const _endPoint );
+	/* overridden in the MultiInstance CC to set the Global Label for each Instance */
+	virtual void SetInstanceLabel(uint8 const _instance, char *label);
+	string GetInstanceLabel(uint8 const _instance);
+	uint8 GetNumInstances() { return (uint8)m_endPointMap.size(); };
+	void SetAfterMark(){ m_dom.SetFlagBool(STATE_FLAG_AFTERMARK, true); }
+	void SetEndPoint( uint8 const _instance, uint8 const _endpoint){ m_endPointMap[_instance] = _endpoint; }
+	bool IsAfterMark()const{ return m_dom.GetFlagBool(STATE_FLAG_AFTERMARK); }
+	bool IsSecured()const{ return m_dom.GetFlagBool(STATE_FLAG_ENCRYPTED); }
+	void SetSecured(){ m_dom.SetFlagBool(STATE_FLAG_ENCRYPTED, true); }
+	bool IsSecureSupported()const { return m_SecureSupport; }
+	void ClearSecureSupport() { m_SecureSupport = false; }
+	void SetSecureSupport() { m_SecureSupport = true; }
+	void SetInNIF() { m_dom.SetFlagBool(STATE_FLAG_INNIF, true); }
+	bool IsInNIF() { return m_dom.GetFlagBool(STATE_FLAG_INNIF); }
+
+	// Helper methods
+	string ExtractValue( uint8 const* _data, uint8* _scale, uint8* _precision, uint8 _valueOffset = 1 )const;
+
+	/**
+	 *  Append a floating-point value to a message.
+	 *  \param _msg The message to which the value should be appended.
+	 *  \param _value A string containing a decimal number to be appended.
+	 *  \param _scale A byte indicating the scale corresponding to this value (e.g., 1=F and 0=C for temperatures).
+	 *  \see Msg
+	 */
+	void AppendValue( Msg* _msg, string const& _value, uint8 const _scale )const;
+	uint8 const GetAppendValueSize( string const& _value )const;
+	int32 ValueToInteger( string const& _value, uint8* o_precision, uint8* o_size )const;
+
+	void UpdateMappedClass( uint8 const _instance, uint8 const _classId, uint8 const _value );		// Update mapped class's value from BASIC class
+
+	typedef struct RefreshValue {
+		uint8 cc;
+		uint8 genre;
+		uint8 instance;
+		uint16 index;
+		std::vector<RefreshValue *> RefreshClasses;
+	} RefreshValue;
+
+protected:
+	virtual void CreateVars( uint8 const _instance ){}
+	void ReadValueRefreshXML ( TiXmlElement const* _ccElement );
+	CompatOptionManager m_com;
+	CompatOptionManager m_dom;
+
+
+public:
+	virtual void CreateVars( uint8 const _instance, uint8 const _index ){}
+
+private:
+	uint32		m_homeId;
+	uint8		m_nodeId;
+	Bitfield	m_instances;
+	OPENZWAVE_EXPORT_WARNINGS_OFF
+	map<uint8,uint8> m_endPointMap;
+	map<uint8, string> m_instanceLabel;
+	OPENZWAVE_EXPORT_WARNINGS_ON
+	bool		m_SecureSupport; 	// Does this commandclass support secure encryption (eg, the Security CC doesn't encrypt itself, so it doesn't support encryption)
+	std::vector<RefreshValue *> m_RefreshClassValues; // what Command Class Values should we refresh ?
+	string		m_commandClassLabel;
 	//-----------------------------------------------------------------------------
 	// Record which items of static data have been read from the device
 	//-----------------------------------------------------------------------------
-	public:
-		enum StaticRequest
-		{
-			StaticRequest_Instances		= 0x01,
-			StaticRequest_Values		= 0x02,
-			StaticRequest_Version		= 0x04
-		};
+public:
+	enum StaticRequest
+	{
+		StaticRequest_Instances		= 0x01,
+		StaticRequest_Values		= 0x02,
+		StaticRequest_Version		= 0x04
+	};
 
-		bool HasStaticRequest( uint8 _request )const{ return( (m_staticRequests & _request) != 0 ); }
-		void SetStaticRequest( uint8 _request ){ m_staticRequests |= _request; }
-		void ClearStaticRequest( uint8 _request );
+	bool HasStaticRequest( uint8_t _request )const{ return( (m_dom.GetFlagByte(STATE_FLAG_STATIC_REQUESTS) & _request) != 0 ); }
+	void SetStaticRequest( uint8_t _request );
+	void ClearStaticRequest( uint8_t _request );
 
-	private:
-		uint8   m_staticRequests;
 
 	//-----------------------------------------------------------------------------
 	//	Statistics
 	//-----------------------------------------------------------------------------
-	public:
-		uint32 GetSentCnt()const{ return m_sentCnt; }
-		uint32 GetReceivedCnt()const{ return m_receivedCnt; }
-		void SentCntIncr(){ m_sentCnt++; }
-		void ReceivedCntIncr(){ m_receivedCnt++; }
-
-	private:
-		uint32 m_sentCnt;				// Number of messages sent from this command class.
-		uint32 m_receivedCnt;				// Number of messages received from this commandclass.
-	};
-
+public:
+	uint32 GetSentCnt()const{ return m_sentCnt; }
+	uint32 GetReceivedCnt()const{ return m_receivedCnt; }
+	void SentCntIncr(){ m_sentCnt++; }
+	void ReceivedCntIncr(){ m_receivedCnt++; }
+
+private:
+	uint32 m_sentCnt;				// Number of messages sent from this command class.
+	uint32 m_receivedCnt;				// Number of messages received from this commandclass.
+
+};
+//@}
 } // namespace OpenZWave
 
 #endif
diff --git a/hardware/openzwave/command_classes/CommandClasses.h b/hardware/openzwave/command_classes/CommandClasses.h
index 7fd650bc95..79fad95433 100644
--- a/hardware/openzwave/command_classes/CommandClasses.h
+++ b/hardware/openzwave/command_classes/CommandClasses.h
@@ -30,6 +30,7 @@
 
 #include <string>
 #include <map>
+#include <list>
 #include "Defs.h"
 
 namespace OpenZWave
@@ -37,6 +38,7 @@ namespace OpenZWave
 	class CommandClass;
 
 	/** \brief Manages a map of command classes supported by a specific Z-Wave node.
+	 * \ingroup CommandClass
 	 */
 	class CommandClasses
 	{
@@ -48,6 +50,7 @@ namespace OpenZWave
 
 		static bool IsSupported( uint8 const _commandClassId );
 		static string GetName(uint8 const _commandClassId);
+		static list<uint8> GetAdvertisedCommandClasses();
 	private:
 		CommandClasses();
 		CommandClasses( CommandClasses const&	);					// prevent copy
@@ -59,12 +62,16 @@ namespace OpenZWave
 			return instance;
 		}
 
-		void Register( uint8 const _commandClassId, string const& _commandClassName, pfnCreateCommandClass_t _create );
+		void Register( uint8 const _commandClassId, string const& _commandClassName, pfnCreateCommandClass_t _create, bool advertised = false );
 		void ParseCommandClassOption( string const& _optionStr, bool const _include );
 		uint8 GetCommandClassId( string const& _name );
 
 		pfnCreateCommandClass_t m_commandClassCreators[256];
 		map<string,uint8>		m_namesToIDs;
+		/* a list of CommandClasses that are advertised on the controllers NIF packet and can be controlled
+		 * via other Nodes
+		 */
+		list<uint8>				m_advertisedCommandClasses;
 
 		// m_supportedCommandClasses uses single bits to mark whether OpenZWave supports a command class
 		// Checking this is not the same as looking for non-NULL entried in m_commandClassCreators, since
diff --git a/hardware/openzwave/command_classes/Configuration.h b/hardware/openzwave/command_classes/Configuration.h
index e97e7f159a..4714f410b2 100644
--- a/hardware/openzwave/command_classes/Configuration.h
+++ b/hardware/openzwave/command_classes/Configuration.h
@@ -36,6 +36,7 @@ namespace OpenZWave
 	class Value;
 
 	/** \brief Implements COMMAND_CLASS_CONFIGURATION (0x70), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Configuration: public CommandClass
 	{
@@ -48,8 +49,8 @@ namespace OpenZWave
 		static uint8 const StaticGetCommandClassId(){ return 0x70; }
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_CONFIGURATION"; }
 
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _parameter, uint8 const _index, Driver::MsgQueue const _queue );
-		void Set( uint8 const _parameter, int32 const _value, uint8 const _size );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _parameter, uint8 const _index, Driver::MsgQueue const _queue );
+		void Set( uint16 const _parameter, int32 const _value, uint8 const _size );
 
 		// From CommandClass
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
diff --git a/hardware/openzwave/command_classes/ControllerReplication.h b/hardware/openzwave/command_classes/ControllerReplication.h
index 338906a869..2050d964c3 100644
--- a/hardware/openzwave/command_classes/ControllerReplication.h
+++ b/hardware/openzwave/command_classes/ControllerReplication.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_CONTROLLER_REPLICATION (0x21), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ControllerReplication: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/DeviceResetLocally.h b/hardware/openzwave/command_classes/DeviceResetLocally.h
index f01e714781..be7c2c002c 100644
--- a/hardware/openzwave/command_classes/DeviceResetLocally.h
+++ b/hardware/openzwave/command_classes/DeviceResetLocally.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_DEVICE_RESET_LOCALLY (0x5a), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class DeviceResetLocally: public CommandClass
 	{
diff --git a/hardware/openzwave/command_classes/DoorLock.h b/hardware/openzwave/command_classes/DoorLock.h
index 331248ba38..eda5073b6d 100644
--- a/hardware/openzwave/command_classes/DoorLock.h
+++ b/hardware/openzwave/command_classes/DoorLock.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_DOOR_LOCK (0x62), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class DoorLock: public CommandClass
 	{
@@ -46,10 +47,8 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_DOOR_LOCK"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -61,12 +60,6 @@ namespace OpenZWave
 
 	private:
 		DoorLock( uint32 const _homeId, uint8 const _nodeId );
-		uint8 m_timeoutsupported;
-		uint8 m_insidehandlemode;
-		uint8 m_outsidehandlemode;
-		uint8 m_timeoutmins;
-		uint8 m_timeoutsecs;
-
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/DoorLockLogging.h b/hardware/openzwave/command_classes/DoorLockLogging.h
index 9661d4d926..149c574315 100644
--- a/hardware/openzwave/command_classes/DoorLockLogging.h
+++ b/hardware/openzwave/command_classes/DoorLockLogging.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_DOOR_LOCK_LOGGING (0x4C), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class DoorLockLogging: public CommandClass
 	{
@@ -46,10 +47,8 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_DOOR_LOCK_LOGGING"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -59,7 +58,6 @@ namespace OpenZWave
 
 	private:
 		DoorLockLogging( uint32 const _homeId, uint8 const _nodeId );
-		uint8 m_MaxRecords;
 		uint8 m_CurRecord;
 	};
 
diff --git a/hardware/openzwave/command_classes/EnergyProduction.h b/hardware/openzwave/command_classes/EnergyProduction.h
index 8f48968f24..fe65712946 100644
--- a/hardware/openzwave/command_classes/EnergyProduction.h
+++ b/hardware/openzwave/command_classes/EnergyProduction.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueDecimal;
 
 	/** \brief Implements COMMAND_CLASS_ENERGY_PRODUCTION (0x90), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class EnergyProduction: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _valueEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _valueEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
